<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source to the Rust file `src/lib/input_file_reader.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>input_file_reader.rs.html -- source</title><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../dark.css"><link rel="stylesheet" type="text/css" href="../../../light.css" id="themeStyle"><script src="../../../storage.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="shortcut icon" href="../../../favicon.ico"><style type="text/css">#crate-search{background-image:url("../../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 8]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu">&#9776;</div><a href='../../../geoip_maxmind/index.html'><div class='logo-container'><img src='../../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!"><img src="../../../brush.svg" width="18" alt="Pick another theme!"></button><div id="theme-choices"></div></div><script src="../../../theme.js"></script><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><a id="settings-menu" href="../../../settings.html"><img src="../../../wheel.svg" width="18" alt="Change settings"></a></div></form></nav><section id="main" class="content"><pre class="line-numbers"><span id="1"> 1</span>
<span id="2"> 2</span>
<span id="3"> 3</span>
<span id="4"> 4</span>
<span id="5"> 5</span>
<span id="6"> 6</span>
<span id="7"> 7</span>
<span id="8"> 8</span>
<span id="9"> 9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
</pre><div class="example-wrap"><pre class="rust ">
<span class="doccomment">//! # input-_file_reader ( output function )</span>
<span class="doccomment">//! </span>
<span class="doccomment">//! simple mod to create an handler for a file</span>
<span class="doccomment">//! and function to read it </span>
<span class="doccomment">//! </span>



<span class="kw">use</span> <span class="ident">std</span>::<span class="ident">fs</span>::<span class="ident">File</span>;
<span class="kw">use</span> <span class="ident">std</span>::<span class="ident">io</span>::<span class="ident">BufReader</span>;




<span class="doccomment">/// open a file and return a result with a BufReader on a File</span>
<span class="doccomment">/// </span>
<span class="doccomment">/// # Arguments</span>
<span class="doccomment">///    *    `file`  - A string slice reference to the filename</span>
<span class="doccomment">/// </span>
<span class="doccomment">/// # Remarks</span>
<span class="doccomment">///     Result&lt;BufReader&lt;File&gt;,String&gt; - Result with two option BufReader&lt;File&gt; </span>
<span class="doccomment">///     if succeed and String if fail</span>
<span class="doccomment">///     BufReader function are ready to read files...</span>
<span class="doccomment">///     </span>
<span class="doccomment">/// </span>
<span class="doccomment">/// # Example</span>
<span class="doccomment">/// </span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// let file = &quot;my_file&quot;;</span>
<span class="doccomment">/// </span>
<span class="doccomment">/// match input_file_reader(&amp;file) {</span>
<span class="doccomment">///     </span>
<span class="doccomment">///     Ok(o) =&gt; { // get the result },</span>
<span class="doccomment">///     Err(e) =&gt; { // error output </span>
<span class="doccomment">///         println!(&quot;{}&quot;,e);</span>
<span class="doccomment">///         // ...</span>
<span class="doccomment">///     }</span>
<span class="doccomment">/// </span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">input_file_reader</span>(<span class="ident">file</span> : <span class="kw-2">&amp;</span><span class="ident">str</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">BufReader</span><span class="op">&lt;</span><span class="ident">File</span><span class="op">&gt;</span>,<span class="ident">String</span><span class="op">&gt;</span> {

    <span class="kw">let</span> <span class="ident">f</span> <span class="op">=</span> <span class="ident">File</span>::<span class="ident">open</span>(<span class="ident">file</span>);

    <span class="kw">match</span> <span class="ident">f</span> {
        <span class="prelude-val">Ok</span>(<span class="ident">b</span>) <span class="op">=</span><span class="op">&gt;</span> {
            <span class="kw">let</span> <span class="ident">buf_reader</span> <span class="op">=</span> <span class="ident">BufReader</span>::<span class="ident">new</span>(<span class="ident">b</span>);
             <span class="prelude-val">Ok</span>(<span class="ident">buf_reader</span>)
        },
        <span class="prelude-val">Err</span>(<span class="ident">e</span>) <span class="op">=</span><span class="op">&gt;</span> {
            <span class="kw">let</span> <span class="ident">err</span> <span class="op">=</span> <span class="macro">format</span><span class="macro">!</span>(<span class="string">&quot;Can t open file {} : {} &quot;</span>, <span class="ident">file</span>, <span class="ident">e</span>);
            <span class="prelude-val">Err</span>(<span class="ident">err</span>)
        }

    }

}</pre></div>
</section><section id="search" class="content hidden"></section><section class="footer"></section><script>window.rootPath = "../../../";window.currentCrate = "geoip_maxmind";</script><script src="../../../aliases.js"></script><script src="../../../main.js"></script><script src="../../../source-script.js"></script><script src="../../../source-files.js"></script><script defer src="../../../search-index.js"></script></body></html>